/*------------------------------------------------*/
/* konverze/io.c                                  */

#include <wchar.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <locale.h>

#define TEXT_LEN 10

int main(void) {
    wchar_t w, ws;
    wchar_t buffer[TEXT_LEN];
    size_t i;
    setlocale(LC_ALL, "");

    printf("stdin je v \"%s\" módu\n", fwide(stdin, 0) > 0 ? "wide" : "narrow");

    buffer[TEXT_LEN-1] = 'x'; // vyplnil nacteny text cely buffer? (viz preskoceni zbytku textu)
    printf("Zadej větu: ");
    if (fgetws(buffer, TEXT_LEN, stdin) == NULL) {
        perror(NULL);
        return EXIT_FAILURE;
    }
    printf("Zadal jsi '%ls'\n", buffer);

    /* Kolikrat je v textu č?  */
    mbrtowc(&ws,"č",4, NULL);
    i = 0;
    printf("Zadal jsi ");
    while(buffer[i] != L'\0') {
        printf("%c%lc%c",
            (buffer[i] == ws) ? '<' :  ' ',
            (wint_t) buffer[i],
            (buffer[i] == ws) ? '>' : ' '); 
        i++;
    }
    printf("\n");
    printf("stdin je v \"%s\" módu\n", fwide(stdin, 0) > 0 ? "wide" : "narrow");

    /* Preskocim zbytek zadaneho textu (az k znaku '\n') */
    while (buffer[TEXT_LEN -1] == L'\0' && buffer[TEXT_LEN -2] != '\n') {
	buffer[TEXT_LEN -1] = L'x';
	if(NULL == fgetws(buffer, TEXT_LEN, stdin)) {
		perror(NULL);
		return EXIT_FAILURE;
	}
    }

    /* Požádám o další znak */
    printf("Zadej znak: ");
    fflush(stdout);
    if((w = fgetwc(stdin)) == WEOF) {
        perror(NULL);
        return EXIT_FAILURE;
    }

    printf("Zadal jsi '%lc'\n", (wint_t) w);
    return 0;
}

/*------------------------------------------------*/
