/*------------------------------------------------*/
/* konverze/io.c                                  */

#include <wchar.h>
#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <locale.h>

#define TEXT_LEN 10

int main(void) {
    wchar_t w, ws;
    wchar_t text[TEXT_LEN];
    size_t i;
	setlocale(LC_ALL, "");

    printf("stdin je v \"%s\" mdu\n", fwide(stdin, 0) > 0 ? "wide" : "narrow");

    buffer[TEXT_LEN-1] = 'x'; // vyplnil nacteny text cely buffer? (viz preskoceni zbytku textu)
    printf("Zadej vtu: ");
    if (fgetws(text, TEXT_LEN, stdin) == NULL) {
        perror(NULL);
        return EXIT_FAILURE;
    }
    printf("Zadal jsi '%S'\n", text);

    /* Kolikrat je v textu ?  */
    mbrtowc(&ws,"",4, NULL);
    i = 0;
    printf("Zadal jsi ");
    while(text[i] != L'\0') {
        printf("%c%lc%c",
            (text[i] == ws) ? '<' :  ' ',
            (wint_t) text[i],
            (text[i] == ws) ? '>' : ' '); 
        i++;
    }
    printf("\n");
    printf("stdin je v \"%s\" mdu\n", fwide(stdin, 0) > 0 ? "wide" : "narrow");

    /* Preskocim zbytek zadaneho textu (az k znaku '\n'). */
    while (buffer[TEXT_LEN -1] == L'\0' && buffer[TEXT_LEN -2] != '\n') {
	text[TEXT_LEN -1] = L'x';
	if(NULL == fgetws(text, TEXT_LEN, stdin)) {
		perror(NULL);
		return EXIT_FAILURE;
	}
    }

    /* Podm o dal znak */
    printf("Zadejte znak: ");
    fflush(stdout);
    if((w = fgetwc(stdin)) == WEOF) {
        perror(NULL);
        return EXIT_FAILURE;
    }

    printf("Zadal jsi '%lc'\n", (wint_t) w);
    return 0;
}

/*------------------------------------------------*/
